#define	DEBUG
/*
RMEEp01
E24系列基準の抵抗計（Arduino単体 - 予備実験）
(C) 2022 JH4VAJ
*/

#define	TITLE			"RMEEp01"
#define	VERSION		"0.9"
#define COPYRIGHT	"(C) 2022 JH4VAJ"

#define	RREF	1.0e3						/* 基準抵抗の値 */


// the setup function runs once when you press reset or power the board
void setup() {
  Serial.begin(9600);
}


void measure_resistance() {
	long	val_x, val_diff;
	float	r;

	const long	val_ref = 1024;		// リファレンス値

	val_x = analogRead(A0);				// 測定値

	val_diff = val_ref - val_x;

#ifdef DEBUG
  Serial.print("val_x: ");
  Serial.print(val_x);
  Serial.print("  val_diff: ");
  Serial.print(val_diff);
  Serial.print("  ");
#endif

  r = ((float)val_x / (float)val_diff) * RREF;
  print_result(r);
}


void print_result(float r) {
  Serial.print(r);
  Serial.println("Ω");
}


// the loop function runs over and over again forever
void loop() {
	measure_resistance();

	delay(1000);
}
